import { Component, ViewChild } from '@angular/core';

import { TreeGridComponent } from 'ej-angular2';

const dataSet1 = [{
    taskID: 1,
    taskName: 'Single Planning',
    startDate: '02/03/2014',
    endDate: '02/07/2014',
    progress: 100,
    duration: 5,
}];


const dataSet2 = [
    {
        taskID: 1, taskName: 'Planning', startDate: '02/03/2014', endDate: '02/07/2014', progress: 100, duration: 5,
        subtasks: [
            { taskID: 2, taskName: 'Plan timeline', startDate: '02/03/2014', endDate: '02/07/2014', duration: 5, progress: 100 },
            { taskID: 3, taskName: 'Plan budget', startDate: '02/03/2014', endDate: '02/07/2014', duration: 5 },
            { taskID: 4, taskName: 'Allocate resources', startDate: '02/03/2014', endDate: '02/07/2014', duration: 5, progress: 100 },
            { taskID: 5, taskName: 'Planning complete', startDate: '02/07/2014', endDate: '02/07/2014', duration: 0, progress: 0 },
            { taskID: 6, taskName: 'Planning complete 1', startDate: '02/07/2014', endDate: '02/07/2014', duration: 0, progress: 0 },
            { taskID: 7, taskName: 'Planning complete 2', startDate: '02/07/2014', endDate: '02/07/2014', duration: 0, progress: 0 },
            { taskID: 8, taskName: 'Planning complete 3', startDate: '02/07/2014', endDate: '02/07/2014', duration: 0, progress: 0 },
            { taskID: 9, taskName: 'Planning complete 4', startDate: '02/07/2014', endDate: '02/07/2014', duration: 0, progress: 0 },
            { taskID: 10, taskName: 'Planning complete 5', startDate: '02/07/2014', endDate: '02/07/2014', duration: 0, progress: 0 },
        ]
    },
    { taskID: 11, taskName: 'Planning 1', startDate: '02/03/2014', endDate: '02/07/2014', progress: 100, duration: 5, },
    { taskID: 12, taskName: 'Planning 2', startDate: '02/03/2014', endDate: '02/07/2014', progress: 100, duration: 5, },
    { taskID: 13, taskName: 'Planning 3', startDate: '02/03/2014', endDate: '02/07/2014', progress: 100, duration: 5, },
    { taskID: 14, taskName: 'Planning 4', startDate: '02/03/2014', endDate: '02/07/2014', progress: 100, duration: 5, },
    { taskID: 15, taskName: 'Planning 5', startDate: '02/03/2014', endDate: '02/07/2014', progress: 100, duration: 5, },
    { taskID: 16, taskName: 'Planning 6', startDate: '02/03/2014', endDate: '02/07/2014', progress: 100, duration: 5, },
    { taskID: 17, taskName: 'Planning 7', startDate: '02/03/2014', endDate: '02/07/2014', progress: 100, duration: 5, },
    { taskID: 18, taskName: 'Planning 8', startDate: '02/03/2014', endDate: '02/07/2014', progress: 100, duration: 5, },
    { taskID: 19, taskName: 'Planning 9', startDate: '02/03/2014', endDate: '02/07/2014', progress: 100, duration: 5, },
];


@Component({
    selector: 'app-root',
    templateUrl: './app.component.html',
    styleUrls: ['./app.component.css']
})
export class AppComponent {
    public treeGridData: any = {};
    public datasource: any = {};
    public selectedRowIndex: any;

    @ViewChild('myTree') treeGrid: TreeGridComponent;

    public constructor() {
        this.datasource = dataSet1;
        this.selectedRowIndex = 4;
    }

    public loadData(selectRow?: number) {
        this.datasource = this.loadSomeData();

        if (selectRow != null) {
            let rowIndex = this.searchRowForId(selectRow);
            this.expandParentNodes(rowIndex);
            this.selectedRowIndex = rowIndex;
        }
    }

    public loadSomeData() {

        return dataSet2;
    }
    // Event trigger while changing datasource dynamically.
    actionComplete(args) {
        if (args.requestType === 'refreshDataSource') {
            // code to done after the dynamic change of datasource.
        }
    }

    /**
     * Search the row index for a given datamodel id
     *
     * @param id the id to be searched for
     */
    searchRowForId(id: number): number {
        const treeObj = $('#TreeGridControl').ejTreeGrid('instance');
        const dataRow = treeObj.model.updatedRecords;
        let rowIdx = -1;

        // check, if updateRecords have the correct values.
        if (dataRow.length !== dataSet2.length) {
            console.log(`---> !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
--->  this is my problem .... in searchRowForId()
---> !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!`);
        }

        for (let i = 0; i < dataRow.length; ++i) {
            if (dataRow[i].taskID === id) {
                rowIdx = i;
                break;
            }
        }
        return rowIdx;
    }

    /**
     * Expand all parent Nodes of current row
     *
     * @param rowIndex: the row index of the node
     */
    expandParentNodes(rowIndex) {
        const treeObj = $('#TreeGridControl').ejTreeGrid('instance');
        let obj = treeObj.model.updatedRecords[rowIndex];

        if (obj == null || obj.parentItem == null) {
            return;
        }

        while (obj.parentItem != null) {
            obj = obj.parentItem;

            if (obj.expanded === false) {
                treeObj.expandCollapseRow(obj.index);
            }
        }
    }

}

